// Copyright (c) 2024-2026 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// operator-map.go
package expr

import (
	"fmt"

	"git.portale-stac.it/go-pkg/expr/kern"
	"git.portale-stac.it/go-pkg/expr/scan"
	"git.portale-stac.it/go-pkg/expr/sym"
)

//-------- map term

func newMapTerm(tk *scan.Token) (inst *scan.Term) {
	return &scan.Term{
		Tk:       *tk,
		Children: make([]*scan.Term, 0, 2),
		Position: scan.PosInfix,
		Priority: scan.PriIterOp,
		EvalFunc: evalMap,
	}
}

func evalMap(ctx kern.ExprContext, opTerm *scan.Term) (v any, err error) {
	// var leftValue, rightValue any
	var leftValue any
	var it kern.Iterator
	// var item any
	var ok bool

	if err = opTerm.CheckOperands(); err != nil {
		return
	}

	if leftValue, err = opTerm.Children[0].Compute(ctx); err != nil {
		return
	}

	if it, ok = leftValue.(kern.Iterator); !ok {
		if it, err = NewIterator(ctx, leftValue, nil); err != nil {
			return nil, fmt.Errorf("left operand of MAP must be an iterable data-source; got %s", kern.TypeName(leftValue))
		}
	}

	v, err = NewIterIter(it, ctx, opTerm.Children[1:])
	return
}

// init
func init() {
	scan.RegisterTermConstructor(sym.SymKwMap, newMapTerm)
}
